VERSION 5.00
Begin VB.Form FrmImgsize 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Set size of Image"
   ClientHeight    =   2040
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   4605
   Icon            =   "ImageSize.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2040
   ScaleWidth      =   4605
   ShowInTaskbar   =   0   'False
   Begin VB.ComboBox Cboom_Unit 
      Height          =   315
      ItemData        =   "ImageSize.frx":000C
      Left            =   1200
      List            =   "ImageSize.frx":0019
      Sorted          =   -1  'True
      TabIndex        =   7
      Text            =   "Pixels"
      Top             =   1080
      Width           =   1095
   End
   Begin VB.TextBox Txt_Res 
      Enabled         =   0   'False
      Height          =   285
      Left            =   1200
      TabIndex        =   5
      Text            =   "100"
      Top             =   360
      Width           =   615
   End
   Begin VB.TextBox Txt_Size 
      Height          =   285
      Left            =   1200
      TabIndex        =   3
      Text            =   "480"
      Top             =   720
      Width           =   615
   End
   Begin VB.CommandButton CancelButton 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3120
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Lbl_SizeUnit 
      Caption         =   "Pixels"
      Height          =   255
      Left            =   1920
      TabIndex        =   10
      Top             =   720
      Width           =   1095
   End
   Begin VB.Label Lbl_DPI 
      Caption         =   "Dpi"
      Enabled         =   0   'False
      Height          =   255
      Left            =   1920
      TabIndex        =   9
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Lbl_Memory 
      Caption         =   "Memory:"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   1560
      Width           =   2775
   End
   Begin VB.Label Lbl_Unit 
      Caption         =   "&Unit:"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label Lbl_Res 
      Caption         =   "&Resolution:"
      Enabled         =   0   'False
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   360
      Width           =   855
   End
   Begin VB.Label Lbl_Size 
      Caption         =   "&Size:"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   720
      Width           =   615
   End
End
Attribute VB_Name = "FrmImgsize"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Function GetImgSize() As Long
  'find image size in pixels
  If Cboom_Unit.Text = "Pixels" Then
    GetImgSize = Val(Txt_Size.Text)
  Else
    GetImgSize = Val(Txt_Size.Text) * Val(Txt_Res.Text)
  End If
End Function

Sub UpdateMemory()
' Update the "memory: " line
Dim Isize As Long
  Isize = GetImgSize
  Lbl_Memory.Caption = "Memory: " & Int(Isize * Isize / 333.333) & " K  (" & Isize & " x " & Str(Isize) & ")"
End Sub

Private Sub CancelButton_Click()
' Close form without changing image size
  IFSMain.SetImgSize 0, True
  Unload Me
End Sub

Private Sub Cboom_Unit_Click()
' Convert image numbe in txtsize when unit changes
Static LastUnit As String

  Lbl_SizeUnit.Caption = Cboom_Unit.Text
  ' Enable resolution line
  Lbl_Res.Enabled = True
  Txt_Res.Enabled = True
  Lbl_DPI.Enabled = True
  
  Select Case Cboom_Unit.Text
    Case "Inches"
      If LastUnit = "Pixels" Or LastUnit = "" Then 'convert from pixels
        Txt_Size.Text = Txt_Size.Text / Txt_Res.Text
      ElseIf LastUnit = "Cm" Then 'convert from cm
        Txt_Res.Text = Int(Txt_Res.Text * 2.54)
        Txt_Size.Text = Txt_Size.Text / 2.54
      End If
      Lbl_DPI.Caption = "Dpi"
    Case "Cm"
      Txt_Res.Text = Int(Txt_Res.Text / 2.54)
      If LastUnit = "Pixels" Or LastUnit = "" Then 'convert from pixels
        Txt_Size.Text = Txt_Size.Text / Txt_Res.Text
      ElseIf LastUnit = "Inches" Then  ' convert from inches
        Txt_Size.Text = Txt_Size * 2.54
      End If
      Lbl_DPI.Caption = "Dots / cm"
    Case "Pixels"
      If LastUnit = "Inches" Or LastUnit = "Cm" Then Txt_Size.Text = Int(Txt_Size * Txt_Res)
      If Lbl_DPI.Caption = "Dots / cm" Then 'convert dots / cm to DPI
        Lbl_DPI.Caption = "DPI"
        Txt_Res.Text = Int(Txt_Res.Text * 2.54)
      End If
      ' Disable resolution line
      Lbl_Res.Enabled = False
      Txt_Res.Enabled = False
      Lbl_DPI.Enabled = False
  End Select
  
  LastUnit = Cboom_Unit.Text
  UpdateMemory
End Sub

Private Sub Form_Deactivate()
  ' Form always keeps focus
  Me.SetFocus
End Sub

Private Sub Form_Load()
  ' Set image size to screen height
  Txt_Size.Text = Screen.Height / Screen.TwipsPerPixelY
  UpdateMemory
End Sub

Private Sub OKButton_Click()
  ' Check for valid size and update image size in IFSMain
Dim Isize As Long

  Isize = GetImgSize
  
  If (Isize > 1600) Then
    MsgBox "Image size must be less the 1600 pixels.", vbInformation, "Too Big"
    Exit Sub
  ElseIf (Isize < 1) Then
    MsgBox "Image size must be at least 1 pixel.", vbInformation, "Too Small"
    Exit Sub
  End If
  
  IFSMain.SetImgSize Isize, False
  
  Unload Me
End Sub

Private Sub Txt_Res_Change()
  UpdateMemory
End Sub

Private Sub Txt_Res_KeyPress(KeyAscii As Integer)
  ' Allow only numbers and bckspc key
  If ((KeyAscii < Asc("0") Or KeyAscii > Asc("9") Or Len(Txt_Res.Text) >= 3) And KeyAscii <> 8) Then KeyAscii = 0
End Sub

Private Sub Txt_Res_LostFocus()
  ' make sure txt_res >= 1
  If Val(Txt_Res.Text) < 1 Then Txt_Res.Text = 1
End Sub

Private Sub Txt_Size_Change()
' Max image size = 1600 pixels
  If GetImgSize > 1600 Then
    If Cboom_Unit.Text = "Pixels" Then
      Txt_Size = 1600
    Else
      Txt_Size = 1600 / Val(Txt_Res.Text)
    End If
  End If
  UpdateMemory
End Sub

Private Sub Txt_Size_KeyPress(KeyAscii As Integer)
  ' allow only numbers, ".", or bckspc key
  If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) And KeyAscii <> Asc(".") And KeyAscii <> 8 Then KeyAscii = 0
  If KeyAscii = Asc(".") And Cboom_Unit.Text = "Pixels" Then KeyAscii = 0
End Sub

Private Sub Txt_Size_LostFocus()
  ' make sure txt_size is greater than 0.1
  If Val(Txt_Size.Text) < 0.1 Then Txt_Size = 0.1
End Sub
