VERSION 5.00
Begin VB.Form FrmMain 
   Caption         =   "Visual IFS Registration"
   ClientHeight    =   3840
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   6090
   Icon            =   "FrmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3840
   ScaleWidth      =   6090
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Cmd_Cancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3360
      TabIndex        =   3
      Top             =   2040
      Width           =   1215
   End
   Begin VB.CommandButton Cmd_OK 
      Caption         =   "OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4680
      TabIndex        =   2
      Top             =   2040
      Width           =   1215
   End
   Begin VB.TextBox Txt_Name 
      Height          =   285
      Left            =   1800
      TabIndex        =   1
      Top             =   1320
      Width           =   4095
   End
   Begin VB.Label Lbl_Directions 
      Caption         =   $"FrmMain.frx":030A
      Height          =   615
      Left            =   1800
      TabIndex        =   0
      Top             =   240
      Width           =   3855
   End
   Begin VB.Image Image1 
      BorderStyle     =   1  'Fixed Single
      Height          =   3645
      Left            =   120
      Picture         =   "FrmMain.frx":039E
      Top             =   120
      Width           =   1560
   End
End
Attribute VB_Name = "FrmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim UserName As String
Dim AppPath As String

Private Sub Cmd_Cancel_Click()
  Unload Me
End Sub

Sub GetRegistration()
  Dim RegFile
  Dim Registered As Boolean
  Dim chrcount As Integer
  Dim password As String, Checkpassword As String
  Dim nextasc As Integer
  On Error GoTo GetRegistration_Err
  
  RegFile = FreeFile
  ' Construct AppPath
  AppPath = App.Path
  If Right(AppPath, 1) <> "\" Then AppPath = AppPath & "\"
  ' Check if info file exists
  If Dir(AppPath & "RegFile.") = "" Then
    GoTo GetRegistration_Err
  End If
  ' read file
  Open AppPath & "RegFile." For Input As #RegFile
  Checkpassword = Input(LOF(RegFile), #RegFile)
  ' decode password
  Randomize (137650846)
  For chrcount = 1 To Len(Checkpassword) - 2
    nextasc = Asc(Mid(Checkpassword, chrcount, 1)) - (Rnd() * 128)
    If nextasc < 0 Then nextasc = nextasc + 256
    password = password & Chr(nextasc)
  Next
  Close #RegFile
  If Val(Mid(password, 1, 9)) <> 137650846 Then
    MsgBox "Corrupt registration information. Registration aborted."
    Unload Me
  End If
  ' get user name
  UserName = Mid(password, 10)
  Exit Sub
  
GetRegistration_Err:
  MsgBox "Error loading registration information."
  Unload Me
  
End Sub

Private Sub Cmd_OK_Click()
  Dim RegFile

  On Error GoTo Cmd_OK_Click_Err
  If Txt_Name.Text <> UserName Then
    MsgBox "Name does not match. Please check that certificate is valid and that name is spelled correctly."
    Exit Sub
  End If
  
  Set RegFile = CreateObject("Scripting.FileSystemObject")
  RegFile.CopyFile AppPath & "RegFile.", "C:\Windows\System\REKAB.1VI"
  If Dir("C:\Windows\System\REKAB.1VI") <> "" Then
    MsgBox "Registration completed successfully!", vbInformation, "Visual IFS Registration"
  Else
    GoTo Cmd_OK_Click_Err
  End If
    
  Unload Me
  Exit Sub
  
Cmd_OK_Click_Err:
  MsgBox "Error writing registration file", vbCritical
  Unload Me
End Sub

Private Sub Form_Load()
  GetRegistration
End Sub
