VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form FrmOptions 
   Caption         =   "Options"
   ClientHeight    =   3675
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   4665
   Icon            =   "FrmOptions.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3675
   ScaleWidth      =   4665
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3240
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "*.EXE"
      DialogTitle     =   "Choose a Web Browser"
      Filter          =   "*.EXE|*.EXE|*.COM|*.COM"
      InitDir         =   "C:\"
   End
   Begin VB.CommandButton Cmd_Cancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2160
      TabIndex        =   11
      Top             =   3240
      Width           =   1095
   End
   Begin VB.CommandButton Cmd_OK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   10
      Top             =   3240
      Width           =   1095
   End
   Begin VB.Frame Fra_Startup 
      Caption         =   "Startup Settings"
      Height          =   1335
      Left            =   120
      TabIndex        =   4
      Top             =   1800
      Width           =   4455
      Begin VB.CheckBox Chk_Color 
         Caption         =   "Show Colors"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   840
         Width           =   1575
      End
      Begin VB.CheckBox Chk_Data 
         Caption         =   "Show Data"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   600
         Width           =   1455
      End
      Begin VB.CheckBox Chk_TBar 
         Caption         =   "Show Toolbar"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   1455
      End
   End
   Begin VB.Frame Fra_Options 
      Caption         =   "Image Settings"
      Height          =   1455
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   4455
      Begin VB.CommandButton Cmd_ChangeColor 
         Caption         =   "Change..."
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2520
         TabIndex        =   8
         Top             =   840
         Width           =   1095
      End
      Begin VB.TextBox Txt_Size 
         Height          =   285
         Left            =   720
         TabIndex        =   1
         Top             =   360
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Size:"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   360
         Width           =   615
      End
      Begin VB.Shape ColorBox 
         BackColor       =   &H00000000&
         BackStyle       =   1  'Opaque
         Height          =   495
         Left            =   1680
         Top             =   720
         Width           =   735
      End
      Begin VB.Label Lbl_Color 
         Caption         =   "Background Color:"
         Height          =   255
         Left            =   240
         TabIndex        =   3
         Top             =   840
         Width           =   1335
      End
      Begin VB.Label Lbl_Pixels 
         Caption         =   "Pixels (0 - Use Default)"
         Height          =   255
         Left            =   1560
         TabIndex        =   2
         Top             =   360
         Width           =   1695
      End
   End
End
Attribute VB_Name = "FrmOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Cmd_Cancel_Click()
  ' Close form and don't save changes
  Unload Me
End Sub

Private Sub Cmd_ChangeColor_Click()
' Show color dialog and set color
  On Error GoTo Cmd_ChangeColor_Click_Err

  With CommonDialog1
    .ShowColor
    ColorBox.BackColor = .Color
  End With
  
  Exit Sub
  
Cmd_ChangeColor_Click_Err:
  If Err.Number <> 32755 Then MsgBox "Error " & Err.Number & ": " & Err.Description, vbCritical, "Error"

End Sub

Private Sub Cmd_OK_Click()
' Write configuration file, load configuration in IFSMain, and close form
Dim OptFile As Integer
  OptFile = FreeFile
  Open App.Path & "\VISIFS.CFG" For Output As #OptFile
  Write #OptFile, Val(Txt_Size.Text), ColorBox.BackColor, (Chk_TBar.Value = 1), (Chk_Data.Value = 1), (Chk_Color.Value = 1)
  Close #OptFile
  IFSMain.GetOptions
  Unload Me
End Sub

Private Sub Form_Load()
' Load Configuration
' Set Variables
Dim OptFile As Integer
Dim ImgSize As Integer, Color As Long
Dim TBarOn As Boolean, DataOn As Boolean, ColorOn As Boolean
' Load Configuration
  OptFile = FreeFile
  Open (App.Path & "\VISIFS.CFG") For Input As #OptFile
  Input #OptFile, ImgSize, Color, TBarOn, DataOn, ColorOn
  Close #OptFile
' Set Variables
  Txt_Size.Text = ImgSize
  ColorBox.BackColor = Color
  If TBarOn Then Chk_TBar.Value = 1
  If DataOn Then Chk_Data.Value = 1
  If ColorOn Then Chk_Color.Value = 1
End Sub

Private Sub Txt_Size_KeyPress(KeyAscii As Integer)
  'allow only numbers and bckspc key
  If (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) And KeyAscii <> 8 Then KeyAscii = 0
End Sub
